/*
 * Author     :  Paul Kocher
 * E-mail     :  pck@netcom.com
 * Date       :  1997
 * Description:  C implementation of the Blowfish algorithm.
 */

#include "usuals.h"  /* typedefs for byte, word16, boolean, etc. */

#define MAXKEYBYTES 56          /* 448 bits */

typedef struct {
  word32 P[16 + 2];
  word32 S[4][256];
} BLOWFISH_CTX;

void Blowfish_Init(BLOWFISH_CTX *ctx, byte *key, int keyLen);
void Blowfish_Encrypt(BLOWFISH_CTX *ctx, word32 *xl, word32 *xr);
void Blowfish_Decrypt(BLOWFISH_CTX *ctx, word32 *xl, word32 *xr);
int Blowfish_Test(BLOWFISH_CTX *ctx);       /* 0=ok, -1=bad */
void Blowfish_Encrypt1(BLOWFISH_CTX *ctx, byte *outbuf, byte *inbuf);
void Blowfish_Decrypt1(BLOWFISH_CTX *ctx, byte *outbuf, byte *inbuf);
